#pragma once

#include "TUSBADM2.h"
#include "DevForm.h"

namespace ADM2Sample {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace System::IO;

	/// <summary>
	/// MainForm ̊Tv
	/// </summary>
	public ref class MainForm : public System::Windows::Forms::Form
	{
	public:
		MainForm(void)
		{
			InitializeComponent();
			//
			//TODO: ɃRXgN^[ R[hǉ܂
			//
			DevStatus = gcnew array<Boolean>(16);
			IdDevForm = gcnew array<DevForm^>(16);
		}

	protected:
		/// <summary>
		/// gp̃\[XׂăN[Abv܂B
		/// </summary>
		~MainForm()
		{
			if (components)
			{
				delete components;
			}
		}
	internal: System::Windows::Forms::Button^  OpenBtn;
	protected: 
	internal: System::Windows::Forms::Timer^  Timer1;
	public: System::Windows::Forms::Button^  FileConvBtn;
	internal: 
	internal: System::Windows::Forms::OpenFileDialog^  OpenFileDialog1;
	public: 
	internal: System::Windows::Forms::ComboBox^  DevIdSel;
	internal: System::Windows::Forms::SaveFileDialog^  SaveFileDialog1;
	public: System::Windows::Forms::Button^  EndAppBtn;
	internal: 
	private: System::ComponentModel::IContainer^  components;
	public: 

	private:
		/// <summary>
		/// KvȃfUCi[ϐłB
		/// </summary>
		array<Boolean>^ DevStatus;// Device Connection Flag TRUE : connecting
		array<DevForm^>^ IdDevForm;//Device Control Panel Form Object


#pragma region Windows Form Designer generated code
		/// <summary>
		/// fUCi[ T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^[ŕύXȂłB
		/// </summary>
		void InitializeComponent(void)
		{
			this->components = (gcnew System::ComponentModel::Container());
			this->OpenBtn = (gcnew System::Windows::Forms::Button());
			this->Timer1 = (gcnew System::Windows::Forms::Timer(this->components));
			this->FileConvBtn = (gcnew System::Windows::Forms::Button());
			this->OpenFileDialog1 = (gcnew System::Windows::Forms::OpenFileDialog());
			this->DevIdSel = (gcnew System::Windows::Forms::ComboBox());
			this->SaveFileDialog1 = (gcnew System::Windows::Forms::SaveFileDialog());
			this->EndAppBtn = (gcnew System::Windows::Forms::Button());
			this->SuspendLayout();
			// 
			// OpenBtn
			// 
			this->OpenBtn->Location = System::Drawing::Point(113, 130);
			this->OpenBtn->Name = L"OpenBtn";
			this->OpenBtn->Size = System::Drawing::Size(109, 32);
			this->OpenBtn->TabIndex = 86;
			this->OpenBtn->Text = L"Open";
			this->OpenBtn->UseVisualStyleBackColor = true;
			this->OpenBtn->Click += gcnew System::EventHandler(this, &MainForm::OpenBtn_Click);
			// 
			// Timer1
			// 
			this->Timer1->Tick += gcnew System::EventHandler(this, &MainForm::Timer1_Tick);
			// 
			// FileConvBtn
			// 
			this->FileConvBtn->BackColor = System::Drawing::SystemColors::Control;
			this->FileConvBtn->Cursor = System::Windows::Forms::Cursors::Default;
			this->FileConvBtn->ForeColor = System::Drawing::SystemColors::ControlText;
			this->FileConvBtn->Location = System::Drawing::Point(242, 15);
			this->FileConvBtn->Name = L"FileConvBtn";
			this->FileConvBtn->RightToLeft = System::Windows::Forms::RightToLeft::No;
			this->FileConvBtn->Size = System::Drawing::Size(65, 57);
			this->FileConvBtn->TabIndex = 84;
			this->FileConvBtn->Text = L"BinFile -> TextFile";
			this->FileConvBtn->UseVisualStyleBackColor = false;
			this->FileConvBtn->Click += gcnew System::EventHandler(this, &MainForm::FileConvBtn_Click);
			// 
			// OpenFileDialog1
			// 
			this->OpenFileDialog1->FileName = L"OpenFileDialog1";
			// 
			// DevIdSel
			// 
			this->DevIdSel->DropDownStyle = System::Windows::Forms::ComboBoxStyle::DropDownList;
			this->DevIdSel->FormattingEnabled = true;
			this->DevIdSel->Items->AddRange(gcnew cli::array< System::Object^  >(16) {L"0", L"1", L"2", L"3", L"4", L"5", L"6", L"7", 
				L"8", L"9", L"A", L"B", L"C", L"D", L"E", L"F"});
			this->DevIdSel->Location = System::Drawing::Point(28, 142);
			this->DevIdSel->Name = L"DevIdSel";
			this->DevIdSel->Size = System::Drawing::Size(66, 20);
			this->DevIdSel->TabIndex = 85;
			// 
			// EndAppBtn
			// 
			this->EndAppBtn->BackColor = System::Drawing::SystemColors::Control;
			this->EndAppBtn->Cursor = System::Windows::Forms::Cursors::Default;
			this->EndAppBtn->ForeColor = System::Drawing::SystemColors::ControlText;
			this->EndAppBtn->Location = System::Drawing::Point(74, 39);
			this->EndAppBtn->Name = L"EndAppBtn";
			this->EndAppBtn->RightToLeft = System::Windows::Forms::RightToLeft::No;
			this->EndAppBtn->Size = System::Drawing::Size(129, 41);
			this->EndAppBtn->TabIndex = 83;
			this->EndAppBtn->Text = L"I";
			this->EndAppBtn->UseVisualStyleBackColor = false;
			this->EndAppBtn->Click += gcnew System::EventHandler(this, &MainForm::EndAppBtn_Click);
			// 
			// MainForm
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 12);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(335, 177);
			this->Controls->Add(this->OpenBtn);
			this->Controls->Add(this->FileConvBtn);
			this->Controls->Add(this->DevIdSel);
			this->Controls->Add(this->EndAppBtn);
			this->Name = L"MainForm";
			this->Text = L"TUSB-0212ADM2 Sample Program";
			this->FormClosed += gcnew System::Windows::Forms::FormClosedEventHandler(this, &MainForm::MainForm_FormClosed);
			this->Load += gcnew System::EventHandler(this, &MainForm::MainForm_Load);
			this->ResumeLayout(false);

		}
#pragma endregion
	private: System::Void MainForm_Load(System::Object^  sender, System::EventArgs^  e) {
			short DevId;

			Timer1->Interval = 300;
			Timer1->Enabled = true;

			DevIdSel->SelectedIndex = 0;

			// Initialize
			for( DevId = 0 ; DevId < 16 ; DevId++ )
			{
				DevStatus[DevId] = false; // Device is not Connected
			}
			 }
private: System::Void MainForm_FormClosed(System::Object^  sender, System::Windows::Forms::FormClosedEventArgs^  e) {
            short DevId;

            Timer1->Enabled = false;
            for( DevId = 0 ; DevId < 16 ; DevId++ )
            {
                if (IdDevForm[DevId] != nullptr)
                {
                    if (IdDevForm[DevId]->Visible)
                    {
                        IdDevForm[DevId]->Close();
                        DevStatus[DevId] = false;
                        Tusbadm2_Device_Close(DevId);
                    }
				}
            }
			}
private: System::Void FileConvBtn_Click(System::Object^  sender, System::EventArgs^  e) {
            String^ ReadFileName;
            String^ WriteFileName;
            System::IO::BinaryReader^ ReadFile;//ǂݏot@CXg[
            System::IO::StreamWriter^ WriteFile;// ۑt@CXg[
            unsigned char tmpByte;

            do{
                OpenFileDialog1->FileName= "";
                OpenFileDialog1->Title = "oCit@Cw";
                OpenFileDialog1->Filter = "oCit@C (*.dat)|*.dat";
                if (OpenFileDialog1->ShowDialog() == System::Windows::Forms::DialogResult::Cancel)
                {
                    return;
                }
            }while(OpenFileDialog1->FileName == "" );
            ReadFileName = OpenFileDialog1->FileName;

            do{
                SaveFileDialog1->OverwritePrompt = true;
                SaveFileDialog1->FileName = "";
                SaveFileDialog1->Title = "ϊt@Cw";
                SaveFileDialog1->Filter = "eLXgۑt@C (*.csv)|*.csv";

                if(SaveFileDialog1->ShowDialog() == System::Windows::Forms::DialogResult::Cancel)
                    return;
            }while(SaveFileDialog1->FileName == "");
            WriteFileName = SaveFileDialog1->FileName;

            ReadFile = gcnew BinaryReader(File::OpenRead(ReadFileName)); //t@CJ
            if( File::Exists(SaveFileDialog1->FileName)) // t@C`FbN
                File::Delete(SaveFileDialog1->FileName);
            WriteFile = gcnew StreamWriter(File::OpenWrite(WriteFileName)); // t@CJ

            WriteFile->WriteLine("Start date time" + "," + DateTime::FromBinary(ReadFile->ReadInt64()).ToString()); // 
            WriteFile->WriteLine("Channel" + "," + ReadFile->ReadByte().ToString()); // ch
            WriteFile->WriteLine("Clock select" + "," + ( ReadFile->ReadByte() == 0 ? "Internal": "External")); // NbNI
            WriteFile->WriteLine("Dividing rate" + "," +  ReadFile->ReadInt32().ToString()); // NbN n=2`5000
            WriteFile->WriteLine("Ch2 clock invert" + "," +  (ReadFile->ReadByte() == 0 ? "Disable": "Enable")); // Ch2NbN]@0:Ȃ 1:
            WriteFile->WriteLine("Input range" + "," +  (ReadFile->ReadByte() == 0 ? "Unipolar": "Bipolar")); // W 0:j|[@1:oC|[
            tmpByte = ReadFile->ReadByte(); // gKI 0:O 1:オ 2: 3:\tgEFA
            WriteFile->WriteLine("Trigger select" + "," +  (tmpByte == 0 ? "External" : (tmpByte == 1 ? "Up edge" : (tmpByte == 2 ? "Down edge": "Software"))));
            WriteFile->WriteLine("Trigger threshold" + "," +  ReadFile->ReadInt32().ToString()); // AiOgK臒l
            WriteFile->WriteLine("Noise cancel level" + "," +  ReadFile->ReadInt32().ToString()); // mCYLZx
            WriteFile->WriteLine("Sampling mode" + "," +  (ReadFile->ReadByte() == 0 ? "Continuation": "Repeat")); // 荞ݓ샂[h 0:A 1:s[g
            WriteFile->WriteLine("Sampling length per one trigger" + "," +  ReadFile->ReadInt32().ToString()); // 1gK̎荞ݒ
            WriteFile->WriteLine("Pre trigger length" + "," +  ReadFile->ReadInt32().ToString()); // vgK

            try{
                do{
                    WriteFile->WriteLine(ReadFile->ReadInt16() & 0xFFF); // I[o[Wrbg̓}XN܂
                }while(true);
            }
            catch( Exception^ e ) //t@CGh
            {
				if( e->GetType() != EndOfStreamException::typeid )
				{
					MessageBox::Show(e->ToString());
				}
            }

            ReadFile->Close();
            WriteFile->Close();

            MessageBox::Show("ϊI܂");
		 }
private: void OpenPanel(short Id)
		 {
            DevStatus[Id] = true;
            IdDevForm[Id] = gcnew DevForm();// Device Control Panel Form Create
            IdDevForm[Id]->SetId(Id);
            IdDevForm[Id]->Show();// Form Show
		 }
private: System::Void OpenBtn_Click(System::Object^  sender, System::EventArgs^  e) {
            short DevId;

            DevId = (short) DevIdSel->SelectedIndex;
            if( DevStatus[DevId] == false )// Device is not connected
            {
                if( Tusbadm2_Device_Open(DevId) == 0 )// Connection check
                    OpenPanel(DevId);
            }
		 }
private: System::Void Timer1_Tick(System::Object^  sender, System::EventArgs^  e) {
            short DevId;

            for( DevId = 0 ; DevId < 16 ; DevId++ )
            {
                if( DevStatus[DevId] )
                {
                    if( IdDevForm[DevId]->Visible == false ) // Device is not visible
                    {
                        Tusbadm2_Device_Close(DevId);
                        DevStatus[DevId] = false;
                    }
                }
            }
		 }
private: System::Void EndAppBtn_Click(System::Object^  sender, System::EventArgs^  e) {
			 this->Close();
		 }
};
}

