//-----------------------------------------------
//TUSB-0212ADM2phCoANZXpAPI
//Visual C++/CLI pW[
//
//2013_11_13@Ѓ^[gH
//Copyright (C) 2013 Turtle Industry Co.,Ltd.
//-----------------------------------------------

#ifndef TUSBADM2_h
#define TUSBADM2_h

using namespace System;
using namespace System::Runtime::InteropServices;

[DllImport("TUSBADM2.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbadm2_Device_Open( short id);
[DllImport("TUSBADM2.DLL", CallingConvention = CallingConvention::Cdecl)]
extern void Tusbadm2_Device_Close( short id);
[DllImport("TUSBADM2.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbadm2_Dio_Read( short id, unsigned char *Data);
[DllImport("TUSBADM2.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbadm2_Dio_Write( short id, unsigned char Data);
[DllImport("TUSBADM2.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbadm2_Adc_Start( short id, int CycLen, int PreLen, unsigned char TrgSel, unsigned char Mode, unsigned char Ch1Only);
[DllImport("TUSBADM2.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbadm2_Adc_Stop( short id);
[DllImport("TUSBADM2.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbadm2_Status_Get( short id, unsigned char *Status, unsigned char *OvfStShort);
[DllImport("TUSBADM2.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbadm2_Length( short id, int *Len1, int *Len2, int *Rate1, int *Rate2 );
[DllImport("TUSBADM2.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbadm2_Data_Get( short id, unsigned char ch, [Out] short Data[],int *Leng);
[DllImport("TUSBADM2.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbadm2_Clock_Select( short id, unsigned char InExt, unsigned char Inv, short Div);
[DllImport("TUSBADM2.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbadm2_ThLevel_Set( short id, short ThLevel, short NLevel);
[DllImport("TUSBADM2.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbadm2_InputType( short id, unsigned char Type1, unsigned char Type2 );
[DllImport("TUSBADM2.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbadm2_CheckInputType( short id, unsigned char *Type1, unsigned char *Type2 );
[DllImport("TUSBADM2.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbadm2_Trigger( short id);
[DllImport("TUSBADM2.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbadm2_TransLimit( short id,int Limit);

static String^ Tusbadm2_GetErrMessage(short retcode)
{
    switch (retcode)
    {
        case 0:
            return "I܂";
        case 1:
            return "IDԍsł";
        case 2:
            return "hCoCXg[Ă܂";
        case 3:
            return "łɃfoCX̓I[vĂ܂";
        case 4:
            return "ڑĂ䐔܂";
        case 5:
            return "I[vł܂ł";
        case 6:
            return "foCX݂܂";
        case 7:
            return "I[vĂ܂";
        case 8:
            return "p[^G[";
        case 9:
            return "USBʐMG[ł";
        default:
            return "sȃG[ł";
    }
}

#endif
